#import <Cocoa/Cocoa.h>

// Things we want to always include for convenience
#import "NSData+ARExtensions.h"
#import "NSDictionary+ARExtensions.h"


@interface ARUtils : NSObject

	+ (void) alert:(NSString *)msg;

	+ (NSString *) tempFileName: (NSString*) appName;

	+ (void) copy:(NSString *)source dest:(NSString *)dest overwrite:(BOOL)overwrite;

	+ (void) remove:(NSString *) path;

	/*
		Creates a directory. If it exists, that's ok. If it exists and isn't a directory, or if it can't be
		created, throws an exception.
	*/
	+ (void) mkdir:(NSString *) path;

	+ (NSString *) applicationVersion;

	// eg. 105 for Leopard, 104 for Tiger
	+ (int) osVersion;

	+ (NSString *) machineModel;
	+ (NSString *) machineModelUti;
	
	+ (NSString *) readWeblocFile:(NSString *) path;

	+ (BOOL) isJavaVersionAvailable:(NSString*) version;
	
	+ (BOOL) isProcessRunning:(NSString *) name;
	+ (void) kill:(NSString*) name signal:(NSString*) signal;
	+ (void) killThoroughly:(NSString *) name initialWait:(int) initialSeconds waitBetweenKills:(int) betweenSeconds ;
	+ (BOOL) waitForDeath:(NSString *) name waitFor:(int) seconds;
@end
