#import <Foundation/Foundation.h>
#import "StreamAdditions.h"
@class Deserialiser;

// see Serialiser.m for notes

// Parent isn't supposed to be public, but it's the only way to have Deserialiser extend it.
@protocol Parent <NSXMLParserDelegate>
- (void) childFinished:(id) result;
- (void) parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName;
@end

@interface Reader : NSObject <Parent> {
	Deserialiser *deserialiser;
	id<Parent> parent;
	NSXMLParser* parser;
	NSDictionary *attributes; // does this actually need to be a property?
	NSMutableString *content;
	id result;
}
@property (retain) NSMutableString *content;
@property (assign) Deserialiser *deserialiser;
@property (assign) id result;
@property (retain) NSDictionary *attributes;
@property (assign) id<Parent> parent;
@property (assign) NSXMLParser* parser;
+ (id) create;
- (void) passTo:(Reader*) reader attributes:(NSDictionary*) att;
- (void) activate;
@end


@interface Deserialiser : Reader {
@private
	NSMutableArray *objects;
	int objectIndex;
	NSMutableDictionary *objectsWithIds;
}

+ (id) readObject:(NSData*) data;
- initWithInputStream:(BlockingInputStream*) i;
- initWithData:(NSData*) data;

- (id) readObject;

@end
