#import "StreamAdditions.h"
#import <objc/runtime.h>
#import "Deserialiser.h"
#import "HasLifecycle.h"
@class RemoteBeanProxy;
@class RemoteBeanCaller;


@interface RemoteBeanCall : NSObject <HasLifecycleWithCancel> {
	RemoteBeanCaller *caller;
	NSThread *thread;
	NSMutableArray *finallyListeners;
	BOOL  _cancelled;
}
@property (readonly) BOOL cancelled;

- (void) addFinallyListener:(BasicBlock) l;
- (void) cancel;

@end

// ------------------------------------------------------------------

@interface RemoteBeanCaller : NSObject

// to be overridden in the subclass
- (void) invoke:(RemoteBeanProxy*) proxy invocation:(NSInvocation*) inv;

// to be called by the subclass's invoke method
- (NSData*) send:(RemoteBeanProxy*) proxy invocation:(NSInvocation*) inv;
- (void) send:(RemoteBeanProxy*) proxy invocation:(NSInvocation*) inv to:(BlockingOutputStream*) os;
- (void) receive:(RemoteBeanProxy*) proxy invocation:(NSInvocation*) inv fromData:(NSData*) data;
- (void) receive:(RemoteBeanProxy*) proxy invocation:(NSInvocation*) inv fromStream:(BlockingInputStream*) is;
- (void) receive:(RemoteBeanProxy *)proxy invocation:(NSInvocation *)inv fromDeserialiser:(Deserialiser*) des;

- (RemoteBeanProxy*) proxyFor:(Protocol *) p;

// Do some RPC on a background thread. You can cancel the returned call or be notified when it finishes.
- (RemoteBeanCall*) callInBackground:(Protocol*) p op:(OneArgBlock) op;

// Cancel the call running on this thread, if there is one. Don't use directly, usually - use callInBackground.
- (void) cancel:(NSThread*) t;

@end



