#import "natpmp.h"

@interface PMP : NSObject {
	natpmp_t natpmp;
	BOOL ok;
	NSString *lastError;
	int lastErrorCode;
	BOOL notAuthorised;
}
@property (assign) int lastErrorCode;
@property (assign) BOOL notAuthorised;
@property (retain) NSString *lastError;
@property (assign) BOOL ok;

/**
 Returns the actual external port used for the mapping; this isn't necessarily the same as the requested one -
 part of the PMP spec is to map to a different, high-numbered port if the requested one is not available.
 
 To just have PMP choose an external port, supply 0.
 
 Returns 0 on failure.
 */
- (int) map:(int) localPort externalPort:(int) externalPort protocol:(int)protocol remove:(BOOL)shouldRemove;

- (NSString*) publicIp;

@end
